//--------------------------------------------------------------------------------------------------
//
// Title       : mux2_1
// Design      : Base Components
// Author      : Steven
// Company     : UW CSE
//
//-------------------------------------------------------------------------------------------------
//
// File        : mips_muxes.v
// Generated   : Mon Mar 20 16:27:21 2006
// From        : interface description file
// By          : Itf2Vhdl ver. 1.20
//
//-------------------------------------------------------------------------------------------------
//
// Description : 
//
//-------------------------------------------------------------------------------------------------
`timescale 1 ns / 1 ps

module m32w_2_1_bot( out, in0, in1, sel) /* synthesis syn_black_box */ ;
input [31:0] in0,in1 ;
input wire sel ;

output wire [31:0] out ;

//}} End of automatically maintained section
// synopsys translate_off
// -- Enter your statements here -- //
assign out = (sel == 0)? in0 : in1;

// synopsys translate_on

endmodule
											  
module m32w_2_1_top( out, in0, in1, sel) /* synthesis syn_black_box */ ;
input [31:0] in0,in1 ;
input wire sel ;

output wire [31:0] out ;

//}} End of automatically maintained section
// synopsys translate_off
// -- Enter your statements here -- //
assign out = (sel == 0)? in0 : in1;	
// synopsys translate_on
endmodule

module m5w_2_1( out, in0, in1, sel) /* synthesis syn_black_box */ ; 
input [4:0] in0,in1 ;
input wire sel ;

output wire [4:0] out ;

//}} End of automatically maintained section
// synopsys translate_off
// -- Enter your statements here -- //
assign out = (sel == 0)? in0 : in1;	  
// synopsys translate_on
endmodule

module m6w_2_1( out, in0, in1, sel) /* synthesis syn_black_box */ ;
input [5:0] in0,in1 ;
input wire sel ;

output wire [5:0] out ;

//}} End of automatically maintained section
// synopsys translate_off
// -- Enter your statements here -- //
assign out = (sel == 0)? in0 : in1;	  
// synopsys translate_on
endmodule

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1_bot}}
module mVw_2_1_bot ( out ,in0 ,in1, sel ) ;
	
parameter width = 32;	
input [width-1:0] in0,in1 ;
input sel ;
wire sel ;

output [width-1:0] out ;
wire [width-1:0] out ;

//}} End of automatically maintained section

// -- Enter your statements here -- //
assign out = (sel == 0)? in0 : in1;	 

endmodule

module mVw_2_1_top ( out ,in0 ,in1, sel )  ;
	
parameter width = 32;	
input [width-1:0] in0,in1 ;
input sel ;
wire sel ;

output [width-1:0] out ;
wire [width-1:0] out ;

//}} End of automatically maintained section

// -- Enter your statements here -- //
assign out = (sel == 0)? in0 : in1;	 

endmodule		 

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module m32w_4_1_bot ( out ,in0 ,in1 ,in2 ,in3 ,sel ) /* synthesis syn_black_box */ ;
		
input wire [31:0] in0,in1,in2,in3 ;
input wire [1:0] sel ;

output wire [31:0] out ;

//}} End of automatically maintained section
// synopsys translate_off
// -- Enter your statements here -- // 
assign out = (sel[1] == 0)? ((sel[0] == 0)? in0 : in1):((sel[0]== 0)? in2 : in3); 
// synopsys translate_on
endmodule 

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module m32w_4_1_top ( out ,in0 ,in1 ,in2 ,in3 ,sel ) /* synthesis syn_black_box */ ;
		
input wire [31:0] in0,in1,in2,in3 ;
input wire [1:0] sel ;

output wire [31:0] out ;

//}} End of automatically maintained section
// synopsys translate_off
// -- Enter your statements here -- // 
assign out = (sel[1] == 0)? ((sel[0] == 0)? in0 : in1):((sel[0]== 0)? in2 : in3);		
// synopsys translate_on
endmodule 


//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module mVw_4_1_bot ( out ,in0 ,in1 ,in2 ,in3 ,sel ) ;
	
parameter width = 32;	
input [width-1:0] in0,in1,in2,in3 ;
input [1:0] sel ;
wire [1:0] sel ;

output [width-1:0] out ;
wire [width-1:0] out ;

//}} End of automatically maintained section

// -- Enter your statements here -- // 
assign out = (sel[1] == 0)? ((sel[0] == 0)? in0 : in1):((sel[0]== 0)? in2 : in3);  

endmodule 

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module mVw_4_1_top ( out ,in0 ,in1 ,in2 ,in3 ,sel ) ;
	
parameter width = 32;	
input [width-1:0] in0,in1,in2,in3 ;
input [1:0] sel ;
wire [1:0] sel ;

output [width-1:0] out ;
wire [width-1:0] out ;

//}} End of automatically maintained section

// -- Enter your statements here -- // 
assign out = (sel[1] == 0)? ((sel[0] == 0)? in0 : in1):((sel[0]== 0)? in2 : in3);	  

endmodule

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module dm32w_1_4_top ( in ,out0 ,out1 ,out2 ,out3 ,sel ) /* synthesis syn_black_box */ ;
	
input wire [31:0] in;
input wire [1:0] sel ;

output wire [31:0] out0, out1, out2, out3;
// synopsys translate_off
assign out0 = (sel == 2'b00)? in: 0; 
assign out1 = (sel == 2'b01)? in: 0;
assign out2 = (sel == 2'b10)? in: 0;
assign out3 = (sel == 2'b11)? in: 0;
// synopsys translate_on
endmodule

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module dm32w_1_4_bot ( in ,out0 ,out1 ,out2 ,out3 ,sel ) /* synthesis syn_black_box */ ;
	
input wire [31:0] in;
input wire [1:0] sel ;

output wire [31:0] out0, out1, out2, out3;
// synopsys translate_off
assign out0 = (sel == 2'b00)? in: 0; 
assign out1 = (sel == 2'b01)? in: 0;
assign out2 = (sel == 2'b10)? in: 0;
assign out3 = (sel == 2'b11)? in: 0;
// synopsys translate_on
endmodule

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module dmVw_1_4_top ( in ,out0 ,out1 ,out2 ,out3 ,sel ) ;
	
parameter width = 32;	
input wire [width-1:0] in;
input wire [1:0] sel ;

output wire [width-1:0] out0, out1, out2, out3;

assign out0 = (sel == 2'b00)? in: 0; 
assign out1 = (sel == 2'b01)? in: 0;
assign out2 = (sel == 2'b10)? in: 0;
assign out3 = (sel == 2'b11)? in: 0;

endmodule

//{{ Section below this comment is automatically maintained
//   and may be overwritten
//{module {mux2_1}}
module dmVw_1_4_bot ( in ,out0 ,out1 ,out2 ,out3 ,sel ) ;
	
parameter width = 32;	
input wire [width-1:0] in;
input wire [1:0] sel ;

output wire [width-1:0] out0, out1, out2, out3;

assign out0 = (sel == 2'b00)? in: 0; 
assign out1 = (sel == 2'b01)? in: 0;
assign out2 = (sel == 2'b10)? in: 0;
assign out3 = (sel == 2'b11)? in: 0;

endmodule
